import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

/*
 * A little class representing the disconnect button
 */
public class DisconnectButton extends JButton implements ActionListener {
	private static final long serialVersionUID = -647777142246910949L;

	// Logic components
	private ServerInteraction server;
	private Screen screen;
	private Game game;
	
	/*
	 * Construct the disconnect button based on the current connection
	 */
	public DisconnectButton (ServerInteraction _server, Screen _screen, Game _game){
		server = _server;
		screen = _screen;
		game = _game;
		
		this.addActionListener(this);
		this.setText( "LEAVE SERVER ALONE !!!" );
	}

	/*
	 * Event listener for the clic on the button
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this) {
			game.closesLarboard();
			server.close();
			screen.displayAuth();
	    }
	} 
}
