import java.awt.*;
import javax.swing.JPanel;

/*
 * Class handling the display of neighbour's boards
 */
public class NeighbourBoard extends JPanel  {
	private static final long serialVersionUID = 2108715394233112290L;
	
	// Data
	private String name;
	private Piece.Type[][] board = new Piece.Type[Board.height][Board.width];
	Grid grid = new Grid(Board.width, Board.height, 11, 5, 20, new Color(155,0,75));
	
	/*
	 * Creates the pannel to display neighbour's board
	 */
	public NeighbourBoard(int x, int y, String _name){
		name = _name;
		this.setBounds(x, y, 200, 280);
	}

	/*
	 * Updates the data of the neighbour's board
	 */
	public void updateContent( Piece.Type[][] _board){
		board = _board;
		grid.setContent(board);
	}

	/*
	 * Updates the name of the neighbour's board
	 */
	public void updateName(String _name){
		name = _name;
	}

	/*
	 * Draw the board
	 */
    public void paintComponent(Graphics g){
        Graphics2D g2d = (Graphics2D)g;   

    	grid.print(g2d);	        
        
    	// Drawing of the name
        g.setColor(new Color(255,155,175));            
        Font font = new Font("Courier", Font.BOLD, 20);
        g.setFont(font);
            
        g.drawString(name, 10, 245);	
    }              

}
