import java.awt.*;
import javax.swing.JPanel;

/*
 * Handles the pannel displaying the next piece
 */
public class NextPiece extends JPanel {
	private static final long serialVersionUID = -9033501685869504403L;
	
	// Display parameters
	public static int width = 5;
	public static int height = 5;
	private static int squareSize = 26;
	private int padding = 10;

	// Logical components
	private Piece toPrint;
	private Grid grid = new Grid(width, height);
	
	/*
	 * Constructs the display grid
	 */
	public NextPiece(){
		this.setBounds(300, 0, width*squareSize + 2*padding, height*squareSize + 2 * padding);
		toPrint = new Piece(Piece.Type.empty, 2,2);
	}

	/*
	 * Changes the current displayed piece
	 */
	public void switchPiece(Piece.Type type){
		toPrint = new Piece(type, 2,2);
	}
	
	/*
	 * Displays the pannel
	 */
    public void paintComponent(Graphics g){
        Graphics2D g2d = (Graphics2D)g;   
        
    	grid.print(g2d);		
		toPrint.print(g2d,squareSize,padding);
    } 
}
