import java.awt.*;
import javax.swing.*;

/*
 * Handles the display of the score board
 */
public class ScoreBoard extends JPanel {
	private static final long serialVersionUID = 7143499873041195763L;

	// Variable labels
	private JLabel score = new JLabel("", JLabel.CENTER);
	private JLabel lines = new JLabel("", JLabel.CENTER);
	private JLabel combo = new JLabel("", JLabel.CENTER);
	private JLabel penalties = new JLabel("", JLabel.CENTER);
	
	/*
	 * Creates the score board and initializes the graphical components
	 */
	public ScoreBoard(){
		this.setBounds(300, 200, 250, 325);
		this.setBackground(new Color(213,173,247));
		this.setBorder(BorderFactory.createRaisedBevelBorder());
		
		// Adding subcomponents
		this.add(label("!!!! " + Client.name + " !!!!", 20 ));
		upStats(0,0,0);
		upPenalties(0);
		
		this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		
		Font police = new Font("Tahoma", Font.BOLD, 30 );
		score.setFont(police);
		score.setForeground(new Color(73,43,97));
		lines.setFont(police);
		lines.setForeground(new Color(73,43,97));
		combo.setFont(police);
		combo.setForeground(new Color(73,43,97));
		penalties.setFont(police);
		penalties.setForeground(new Color(73,43,97));

		this.add(label(" ", 15 ));
		this.add(label("U CAN HAZ ZIS MANY LINEZ :", 15 ));
		this.add (lines);
		this.add(label(" ", 8 ));
		this.add(label("ALL UR PUNTS R OVER ", 15 ));
		this.add (score);
		this.add(label(" ", 8 ));
		this.add(label("WE REQUIRE MOAR COMBO : ", 15 ));
		this.add (combo);
		this.add(label(" ", 8 ));

		this.add(label("YO DAWG I HEARD U LIKE LINEZ," ,10));
		this.add(label("SO I IZ ABOUT TO SEND U ZIS MANY LINEZ", 10));
		this.add(label("SO U CAN HAZ LINEZ WHILE U HAZ LINEZ", 10));
		 
		this.add (penalties);
	}

	/*
	 * Provides a text label with the given content
	 */
	private JLabel label(String content, int size) {
		JLabel label = new JLabel();
		label.setText(content);
		Font police = new Font("Tahoma", Font.BOLD, size );
		label.setFont(police);
		label.setForeground(new Color(73,43,97));
		label.setAlignmentY(Component.LEFT_ALIGNMENT);
		return label;
	}

	/*
	 * Updates the score contents of the interface
	 */
	public void upStats (int _lines, int _score, int _combo){
		score.setText(Integer.toString(_score));
		lines.setText(Integer.toString(_lines));
		combo.setText(Integer.toString(_combo));
	}

	/*
	 * Updates the penalties display
	 */
	public void upPenalties (int _penalties){
		penalties.setText(Integer.toString(_penalties));
	}

}
