import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JButton;

/*
 * Graphical button for the leader of the game to start the tetris
 */
public class StartButton extends JButton implements ActionListener {
	private static final long serialVersionUID = 2923083139512536903L;
	private ServerInteraction server;
	 
	/*
	 * Construct the button to start the tetris with the server it communicates with
	 */
	StartButton(ServerInteraction _server) {
		server = _server;
		this.setBorder(null);
		this.addActionListener(this);
	}
	
	/*
	 * Display the graphical component (the background image)
	 */
    public void paintComponent(Graphics g){
         try {
        	 Image img = ImageIO.read(new File("go.png"));
             g.drawImage(img, 0, 0, this);
        } catch (IOException e) {}
    }    
    
    /*
     * Updates the visibility of the button according to the authorization of the client to start or not the game
     */
    public void refresh() {
    	if (server.players.isLeader()){
    		this.setVisible(true);
    	}
    	else {
    		this.setVisible(false);
    	}
    }

    /*
     * Deals with the clic on the button
     */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this) {
				server.tryStart();
	    }
	} 
}