import java.io.*;
import java.net.*;

/**
 * Basic structure of the server, handles the global structure and creates the clientList
 */
public class Server {
	// Settings
	private static int serverPort = 4242;
	public static int serverTimeOut = 4000;
	
	// Logical components
	private static ServerSocket serverSocket;
	private static ClientsList clientsList = new ClientsList();
	private static BufferedReader userIn; // user input

	public static void main(String[] args) {
	    userIn = new BufferedReader(new InputStreamReader(System.in));
	     
		initialize();
		
		// Creates the getter in a different thread, so as to maintain the players list.
		ClientGetter getter = new ClientGetter(serverSocket, clientsList);
	    Thread getterThread = new Thread(getter);
	    getterThread.setName("MemeTris Server -  Client handler");
	    getterThread.setPriority(Thread.MIN_PRIORITY);
	    getterThread.start();
	}
	
	/**
	 * Initializes the server socket on default port and ask for a new port is this one is busy
	 */
	private static void initialize(){
		try {	     
			serverSocket = new ServerSocket(serverPort);
			serverSocket.setSoTimeout(serverTimeOut);
			System.out.println("!!!! SERVR SOCKT INITIALIZASHUN COMPLETD !!!!");
			
			// Try to connect on the current port
		    try
		    {
		    	InetAddress host = InetAddress.getLocalHost();
		    	System.out.println("mah ip r : " + host.getHostAddress());
		    	System.out.println("mah namz r : " + host.getHostName());
		    	System.out.println("mah port r : " + serverPort + "\n");
		    }
		    catch (UnknownHostException uhe) {
				System.err.println("[O NOES ! I DOESNT KNOWZ HOST =(]\n" + uhe);
			}
		} 
		
		// Handles the case where the port is busy
		catch (IOException ioe){
			System.out.println("NOES CAN SERVR SOCKT INITIALIZASHUN =( PERHAPZ ALL UR PORTZ " + serverPort + " R BELONG TO ANOTHER CASTL... TRY AGAIN !");
			try {
				System.out.println("I CAN HAZ PORT PLZ PLZ PLZ ? ");
				serverPort = Integer.parseInt(userIn.readLine());
			} catch (IOException e) {
				System.out.println("I NO UNDERSTAND WHAT PORTZ I CAN HAZ =(");
			}
			
			// Recursive call to try again with the new port
			initialize();
		}
	}
}
